function lx=logistic(mu,x0,np)
%  function lx=logistic(mu,x0,np)
%  Implements lx(n+1) = mu * lx(n) * [1 - lx(n)]
%  returns first np iterates starting with x0
lx=zeros(np+1,1);
lx(1)=x0;
for n=2:np+1; lx(n) = mu * lx(n-1) * (1 - lx(n-1)); end
end
