%	dcorrel uses:
%	z -- input column vector of data samples
%	automatically tests all embedding dimensions from dim1 to dim2 (<8)
%	and calculates regression for several selections of range
%	creates diary file DCORREL.DIA and data files COFEPS.MAT
%		and LEVELS.MAT
%	calls dcorr.m
%
%	This program is distributed as a supplement to the book
%	"Biomedical Signal Processing and Signal Modeling" by E. N. Bruce,
%	published by Wiley, 2000.  It is provided for educational use only.
%  While every effort has been made to insure its suitability to illustrate
%  principles described in the above book, no specific feature or capability 
%  is implied or guaranteed.
tstart=clock;
cofeps=zeros(7,50);
m=length(z);
diary dcorrel.dia
for dim=dim1:dim2
disp('=====================================')
disp('Embedding dimension = '), disp(dim)
if dim==1
	x=z;
end
if dim==2
	x=[z(1:m-1) z(2:m)];
end
if dim==3
	x=[z(1:m-2) z(2:m-1) z(3:m)];
end
if dim==4
	x=[z(1:m-3) z(2:m-2) z(3:m-1) z(4:m)];
end
if dim==5
	x=[z(1:m-4) z(2:m-3) z(3:m-2) z(4:m-1) z(5:m)];
end
if dim==6
	x=[z(1:m-5) z(2:m-4) z(3:m-3) z(4:m-2) z(5:m-1) z(6:m)];
end
if dim==7
	x=[z(1:m-6) z(2:m-5) z(3:m-4) z(4:m-3) z(5:m-2) z(6:m-1) z(7:m)];
end
[p,n]=size(x)
dcorr
cofeps(dim,1:50)=ceps(1:50);
end % of d loop
runtime=etime(clock,tstart)
diary off
