function lx=logistic(mu,x0,np)
%  function lx=logistic(mu,x0,np)
%  Implements lx(n+1) = mu * lx(n) * [1 - lx(n)]
%  returns first np iterates starting with x0
%	This program is distributed as a supplement to the book
%	"Biomedical Signal Processing and Signal Modeling" by E. N. Bruce,
%	published by Wiley, 2000.  It is provided for educational use only.
%  While every effort has been made to insure its suitability to illustrate
%  principles described in the above book, no specific feature or capability 
%  is implied or guaranteed.
lx=zeros(np+1,1);
lx(1)=x0;
for n=2:np+1; lx(n) = mu * lx(n-1) * (1 - lx(n-1)); end
end
