%	This program is distributed as a supplement to the book
%	"Biomedical Signal Processing and Signal Modeling" by E. N. Bruce,
%	published by Wiley, 2000.  It is provided for educational use only.
%  While every effort has been made to insure its suitability to illustrate
%  principles described in the above book, no specific feature or capability 
%  is implied or guaranteed.
%
% circadian.m
%	Displays Body Temperature (tb)and Oxygen Consumption (vo2)
%         over 48 hour period (t) for a pigeon.
%  Both variables appear to have circadian variations. 
%
load circadian.mat
figure
subplot(211)
plot(t, tb)
ylabel('T_b (deg)')
title('Body Temperature (T_b) and Oxygen Consumption (V_O_2) over 48 Hours')
axis([0 50 37 42])
subplot(212)
plot(t,vo2)
ylabel('V_O_2 (ml/min)')
xlabel('Time (hours)')
axis([0 50 3 9])

