function [cy,vary,ucl,lcl]=covstat(y)
%	[cy,vary,ucl,lcl]=covstat(y)
%	This program is distributed as a supplement to the book
%	"Biomedical Signal Processing and Signal Modeling" by E. N. Bruce,
%	published by Wiley, 2000.  It is provided for educational use only.
%  While every effort has been made to insure its suitability to illustrate
%  principles described in the above book, no specific feature or capability 
%  is implied or guaranteed.
cy1=xcov(y,'biased');
cy=cy1(floor(length(cy1)/2)+1:length(cy1));
vary=zeros(size(cy));
ln1=length(cy1);lncy=length(cy);
sumc2=sum(cy1.^2);
for m=1:lncy
   for r=m+1:ln1-m
      vary(m)=vary(m)+cy1(r+m)*cy1(r-m);
   end
   vary(m)=(vary(m)+sumc2)/lncy;
ucl(m)=cy(m)+1.96*sqrt(vary(m));
lcl(m)=cy(m)-1.96*sqrt(vary(m));
end
