% rsa5.m -- This mfile loads rsa.mat and
% plots 2 cycles of each frequency--JAR used for checking data
% lofreq=Col(1) = .25 Hz ilv; lo_hr, t(1:38)
% hifreq=Col(2) = .35 Hz ilv; hi_hr, t(1:28) 
% midfrq=col(3) = .3 Hz ilv;  mid_hr,  t(1:32)
%
% rsa.mat =  10 seconds (t) of Instantaneous Lung Volume (ilv) and  
%corresponding R-R intervals of heart rate (hr) data.   
%Each column = ilv (or hr) at a different breathing frequency.  
%All data were sampled at 5 Hz. Measurements for ilv    
%were made in mL and hr in ms.                          
%                                                      
%	This program is distributed as a supplement to the book
%	"Biomedical Signal Processing and Signal Modeling" by E. N. Bruce,
%	published by Wiley, 2000.  It is provided for educational use only.
%  While every effort has been made to insure its suitability to illustrate
%  principles described in the above book, no specific feature or capability 
%  is implied or guaranteed.

load rsa.mat
%Plot Data
subplot(211)
plot(ilv,'*-')
title('Blue = approx .25 Hz, Red = .3 Hz, Green = .35 Hz')
ylabel('Inst. Lung Volume (mL)')

subplot(212)
plot(hr,'*-')
ylabel('R-R interval of Heart Rate (ms)')
xlabel('Sample #')

lofreq=ilv(1:38,1);
hifreq=ilv(1:28,2);
midfrq=ilv(15:46,3);

lo_hr=hr(1:38,1);
hi_hr=hr(1:28,2);
mid_hr=hr(15:46,3);

figure
subplot(211)

plot(t(1:38),lofreq,'bp-'), hold on, plot(t(1:28),hifreq,'g*-'), plot(t(1:32),midfrq,'rd-')
title('Blue * = approx .25 Hz, Red Dia. = .3 Hz, Green * = .35 Hz')
ylabel('Inst. Lung Volume (mL)')
subplot(212)
plot(t(1:38),lo_hr,'bp-'), hold on, plot(t(1:28),hi_hr,'g*-'), plot(t(1:32),mid_hr,'rd-')
xlabel('Time (sec)')
ylabel('R-R interval of Heart Rate (ms)')
